%% trajson code 
function [x v] = trajson(sys,W,lambda,t)
n=length(t);
A=sys.A;
B=sys.B;
C=sys.C;
T=find(sum((W.t'*ones(1,n)==ones(length(W.t),1)*t)));
nx=size(C,2);
nv=size(B,2);

%% Find when to interact
cvx_begin
variables x(nx,n) v(nv,n-1)
minimize(sum(sum((W.xy-C*x(:,T)).^2))+lambda*sum(norms(v',1,2),1))
subject to
x(:,2:end) == A*x(:,1:end-1)+B*v;
cvx_end

%% Fix interaction time instances, relax regularization
ind= find(norms(v',1,2)>0.0001);
disp(['# of control changes: ' num2str(length(ind))])
ind_n=setdiff(1:n-1,ind);
cvx_begin
variables x(nx,n) v(nv,n-1)
minimize(sum(sum((W.xy-C*x(:,T)).^2)))
subject to
v(:,ind_n)==0;
x(:,2:end) == A*x(:,1:end-1)+B*v;
cvx_end